import java.util.Random;

class EssaiArbresGenerique {
	public static void main(String[] args) {
		/*** Partie 1 ***/
		ArbreGenerique<Integer> a1, a2;

		a1 = new ArbreGenerique<>(
			new NoeudGenerique<>(
				new NoeudGenerique<>(null, 2, null),
				1,
				new NoeudGenerique<>(
					new NoeudGenerique<>(null, 4, null),
					3,
					null
					)
				)
			);
		a2 = new ArbreGenerique<>(
			new NoeudGenerique<>(
				null,
				1,
				new NoeudGenerique<>(
					null,
					2,
					new NoeudGenerique<>(
						null,
						3,
						new NoeudGenerique<>(null, 4, null)
						)
					)
				)
			);
		System.out.println("Arbre a1 : ");
		System.out.println(a1);
		System.out.println("Arbre a2 : ");
		System.out.println(a2);
		
		/*** Partie 2 et suite : ABR, insertion et suppression ***/
		Arbre a = new Arbre();
		Random r = new Random();
		int[] t = ES.genererTableau(r);

		for (int i = 0; i < t.length; i++)
			a.insertion(t[i]);
		System.out.println("Arbre construit :");
		System.out.println(a);
		for (int i = 0; i < 3; i++) {
			int indice = r.nextInt(t.length);
			System.out.println("Suppression de " + t[indice] + " :");
			a.suppression(t[indice]);
		}
		System.out.println("Suppression de 100 :");
		a.suppression(100);
		System.out.println("Arbre resultant :");
		System.out.println(a);
		System.out.println("Séquence resultante :");
		System.out.println(a.afficheSequence());
	}
}
