class Operations {
	static int nbNoeuds(Noeud r) {
		if (r == null)
			return 0;
		else
			return 1 + nbNoeuds(r.fg) + nbNoeuds(r.fd);
	}

	static int hauteur(Noeud r) {
		if (r == null)
			return 0;
		else
			return 1 + Math.max(hauteur(r.fg), hauteur(r.fd));
	}

	static String toStringRec(Noeud r, int indent) {
		if (r == null)
			return "";
		else {
			String result;
			result = toStringRec(r.fd, indent + 1);
			for (int i = 0; i < indent; i++)
				result += "  ";
			result += r.et + "\n";
			result += toStringRec(r.fg, indent + 1);
			return result;
		}
	}

	static String toString(Noeud r) {
		return toStringRec(r, 0);
	}

	static String afficheSequence(Noeud r) {
		if (r == null)
			return "";
		else
			return afficheSequence(r.fg) + r.et + " " + afficheSequence(r.fd);
	}

	static boolean recherche(Noeud r, int et) {
		if (r == null)
			return false;
		else {
			if (r.et == et)
				return true;
			if (r.et < et)
				return recherche(r.fd, et);
			return recherche(r.fg, et);
		}
	}

	static Noeud insertion(Noeud r, int et) {
		if (r == null)
			return new Noeud(null, et, null);
		else {
			if (r.et < et)
				r.fd = insertion(r.fd, et);
			else
				r.fg = insertion(r.fg, et);
			return r;
		}
	}

	static int max(Noeud r) {
		if (r == null)
			return Integer.MIN_VALUE;
		else if (r.fd != null)
			return max(r.fd);
		else
			return r.et;
	}

	static Noeud suppression(Noeud r, int et) {
		if (r == null)
			return null;
		else {
			if (r.et == et) {
				if ((r.fg == null) && (r.fd == null))
					return null;
				if (r.fg == null)
					return r.fd;
				if (r.fd == null)
					return r.fg;
				r.et = max(r.fg);
				r.fg = suppression(r.fg, r.et);
				return r;
			}
			if (r.et < et)
				r.fd = suppression(r.fd, et);
			else
				r.fg = suppression(r.fg, et);
			return r;
		}
	}
}
